<p dir="rtl" align="center">بسم الله الرحمن الرحیم</p>

<p dir="rtl" align="right">
 فهرست مطالب
</p>

<p dir="rtl" align="right">

[گام 1 - به روز رسانی سیستم](#گام1)

</p>
<p dir="rtl" align="right">

[گام 2 - نصب Apache](#گام2)|

</p>
<p dir="rtl" align="right">

[گام 3 - بررسی وضعیت Apache ](#گام3)|

</p>
<p dir="rtl" align="right">

[گام 4 - تنظیمات هاست مجازی](#گام4)|

</p>

<span id="گام3" dir="rtl" align="right">گام 1 - به روز رسانی سیستم</span>

```r
sudo apt update
```

به روز رسانی سیستم
<span id="گام3">گام 2 - نصب Apache</span>

```r
sudo apt install apache2
```

نصب Apache در Ubuntu
<span id="گام3" dir="rtl" align="right">گام 3 - بررسی وضعیت Apache </span>

```r
sudo systemctl status apache2
```
<p dir="rtl" align="justify">
وضعیت آپاچی را بررسی کنید<br>
 آدرس IP خود را در مرورگر باز کنید تا بررسی کنید آیا سرور آپاچی در حال بارگیری است یا خیر؟
<br>
<br>
<br>
<span id="گام4">گام 4 - تنظیمات هاست مجازی</span><br>
 پوشه مربوط به دامنه خود را روی سرور ایجاد کنید<br>
 </p>

```r
sudo mkdir /var/www/domain-name
```

<p dir="rtl" align="justify"> به پوشه دامنه خود مجوز بدهید</p>

```r
sudo chmod -R 755 /var/www/domain-name
```

<p dir="rtl" align="justify"> ایجاد فایل نمونه index.html:</p>

```r
touch /var/www/domain-name/index.html
echo "Your domain is now online" > /var/www/domain-name/index.html
```

<p dir="rtl" align="justify"> ایجاد فایل host مجازی :</p>

```r
sudo nano /etc/apache2/sites-available/domain-name.conf
```

<p dir="rtl" align="right"> متن زیر را به فایل پیکربندی هاست (domain-name.conf) اضافه کنید :</p>

```r
    <VirtualHost *:80>
        ServerAdmin webmaster@localhost
        ServerName domain-name
        ServerAlias www.domain-name
        DocumentRoot /var/www/domain-name
        ErrorLog ${APACHE_LOG_DIR}/error.log
        CustomLog ${APACHE_LOG_DIR}/access.log combined
    </VirtualHost>
```

<p dir="rtl" align="justify"> برای فعال کردن فایل از a2ensite استفاده کنید:</p>

```r
sudo a2ensite domain-name.conf 
or 
sudo a2ensite /etc/apache2/sites-available/domain-name.conf
```

<p dir="rtl" align="justify"> در مرحله بعد باید فایل default را غیرفعال کنیم:</p>


```r
sudo a2dissite 000-default.conf
```

<p dir="rtl" align="justify"> خطاها را بررسی کنید: </p>

```r
sudo apache2ctl configtest
```

<p style="background-color:black;color:white;" >
    <code>
The output should be Syntax OK
<br>
Restart Apache and navigate to your domain on the browser
</code>
</p>


```r
sudo systemctl restart apache2
```

<br>

[منبع](https://www.virtono.com/community/tutorial-how-to/how-to-install-apache-on-ubuntu-20-04%EF%BF%BC/)

<p dir="rtl" align="center">صلوات</p>
