# How to Install Ubuntu on VMware #

Firstly, you need to enable virtualization from BIOS and download VMware and the Ubuntu ISO file on your system. Finally, you'd create a VMware virtual machine and install Ubuntu inside the VM.
## Step 1: Enable Virtualization Using BIOS##

To enable virtualization on your system, follow the given steps:

    Restart your system. Press the designated Fn-key or Esc key to enter the BIOS setup.
    Navigate to the Advanced Settings page and locate the Virtualization option. It may appear as SVM, Intel VT-x, Intel Virtualization Technology, or AMD-V.
    Enable the feature and press F10 to save changes and exit.
    Your system will restart and then boot to the desktop. Launch Task Manager and switch to the Performance tab. Now, it will show the Virtualization feature as enabled.

## Step 2: Download VMware and the Ubuntu ISO File##

* Download VMware and the Ubuntu ISO from the respective websites.

Download: VMware Workstation Player

Download: Ubuntu

Navigate to the Downloads folder and install VMware with administrator privileges. Launch the app to check if it runs without any issues.
## Step 3: Create a Linux Virtual Machine##

Launch VMware Workstation Player on your system. Click on the Create a New Virtual Machine option present on the home page.