<div dir="rtl" align="right">
بسم الله الرحمن الرحیم


پیش نیازهای تغییر آی پی در سرور مجازی لینوکس

قبل از تغییر آدرس IP خود، حتماً آدرس IP فعلی را خودتان چک کنید. برای این کار، نیاز به دستورات پیچیده ای ندارید، می توانید از دستور زیر برای این کار استفاده کنید:

```r
ip a
```

تغییر IP در لینوکس با استفاده از ifconfig

هرچند که دستور ifconfig منسوخ شده است و ما توصیه می کنیم که از دستور ip استفاده کنید، اما از دستور ifconfig برای تغییر دادن آدرس IP می توانید استفاده کنید:

```r
which ifconfig

/usr/sbin/ifconfig
```

برای آن که آدرس IP را در سرور مجازی لینوکس تغییر دهید، می توانید دستور ifconfig را به همراه نام رابط شبکه و آدرس آی پی جدیدی که می خواهید روی سیستم خودتان تغییر دهید، وارد کنید.

برای اختصاص دادن ماسک زیرشبکه، می‌توانید یا یک بند netmask به همراه ماسک زیرشبکه اضافه کنید یا مستقیماً از نماد CIDR استفاده کنید.

```r
ifconfig <interface_name> <ip_address> netmask <netmask_address>
```

توجه: برای تغییر آدرس آی پی شما باید در سیستم خودتان administrator باشید.

به عنوان مثال، با توجه به آدرس‌های IP استفاده شده در بخش‌های قبلی، اگر می‌خواهیم آدرس IP خود را به 192.168.178.32/24 تغییر دهیم، باید دستور زیر را اجرا کنیم.

```r
ifconfig enp0s3 192.168.178.32/24

ifconfig enp0s3 192.168.178.32 netmask 255.255.255.0
```
برای اطمینان از اینکه آدرس IP شما به درستی تغییر کرده است، می توانید دستور ifconfigرا دنبال شده توسط نام آداپتور شبکه خود اجرا کنید.

```r
ifconfig <interface_name>
```



[منبع](https://asamserver.com/blog/change-ip-on-ubuntu-debian-centos/)
</div>