<div align="justify" dir="rtl">

<p align="center" dir="rtl">بسم الله الرحمن الرحیم</p>

### استفاده از setfacl برای تنظیم دسترسی خاصِ کاربر خاص و پوشه و فایل خاص:

### نصب acl در اوبونتو:

<div align="left" dir="ltr">

```r
apt-get install acl
```

</div>

### دستور زیر تمامی دسترسی ها را لیست می کند:

<div align="left" dir="ltr">

```
ls -lR
```



### توضیح:

| Option | Description                                            |
| -----  | ----------------------------------------------------   |
|  ls:   | این دستور تمام محتویات دایرکتوری فعلی را فهرست می کند. |
| -lR:   | این گزینه تمام محتویات دایرکتوری و زیر شاخه فعلی را با اندازه، اطلاعات مجوز، اطلاعات مالک، اطلاعات گروه، زمان آخرین تغییر و غیره لیست می کند.|

</div>



کاربر faru5903 هیچ دسترسی به پوشه و زیر شاخه های /home/folder ندارد

<div align="center" dir="ltr">

| Option | Description |
| ------ | ----------- |
|  (r)   |    Read     |
|  (w)   |    Write    |
|  (x)   |   Execute   |

</div>

<div align="left" dir="ltr">

```
sudo setfacl -R -m u:faru5903:--- /home/folder 
```

</div>

کاربر faru5903 همه دسترسی ها(خواندن و نوشتن و اجرا) به پوشه و زیر شاخه های  /home/folder  دارد

<div align="left" dir="ltr">

```
sudo setfacl -R -m u:faru5903:rwx /home/folder
```

</div>

کاربر faru5903 دسترسی فقط خواندن به پوشه و زیر شاخه های /home/folder دارد

<div align="left" dir="ltr">

```
sudo setfacl -R -m u:faru5903:r /home/folder
```

</div>

کاربر faru5903 دسترسی فقط اجرا به پوشه و زیر شاخه های /home/folder دارد

<div align="left" dir="ltr">

```
sudo setfacl -R -m u:faru5903:x /home/folder
```

</div>

کاربر faru5903 دسترسی فقط نوشتن به پوشه و زیر شاخه های /home/folder دارد

<div align="left" dir="ltr">

```
sudo setfacl -R -m u:faru5903:w /home/folder
```

</div>

<p align="center" dir="rtl">صلوات</p>

</div>