# install apache on ubunto 20.04 #
---
## ●  Step 1 — Installing Apache ##

###  1: <code>*$ sudo apt update*</code> ##
###  2: <code>*$ sudo apt install apache2*</code> ##

## ● Step 2 — Adjusting the Firewall ##

<p><red> List the ufw application profiles by typing: </red></p>

###  <code>*$ sudo ufw app list*</code> ###

#### Output: ####
>  + Available applications:<br>
    + Apache<br>
    + Apache Full<br>
    + Apache Secure<br>
    + OpenSSH<br>

### <code>*$ sudo ufw allow 'Apache'*</code> ##

## ● Step 3 — Checking your Web Server ##

###  <code>*$ sudo systemctl status apache2*</code> ###

#### Output: ####
>  apache2.service - The Apache HTTP Server
     Loaded: loaded (/lib/systemd/system/apache2.service; enabled; vendor preset: enabled)
     Active: active (running) since Thu 2020-04-23 22:36:30 UTC; 20h ago
       Docs: https://httpd.apache.org/docs/2.4/
   Main PID: 29435 (apache2)
      Tasks: 55 (limit: 1137)
     Memory: 8.0M
     CGroup: /system.slice/apache2.service
             ├─29435 /usr/sbin/apache2 -k start
             ├─29437 /usr/sbin/apache2 -k start
             └─29438 /usr/sbin/apache2 -k start

## Try typing this at your command prompt(server):  ##
###  <code>*$ hostname -I*</code> ###
 Another option is to use the Icanhazip tool, <br> 
 which should give you your public IP address as read <br>  
 from another location on the internet:   
###  <code>*$ curl -4 icanhazip.com*</code> ###

When you have your  IP address(server), enter it into your address bar(browser):
http://your_server_ip
---
# uninstall apache on ubunto 20.04 #
