<p align="center" dir="rtl">بسم الله الرحمن الرحیم</p>

# <p align="right" dir="rtl" >PHP نصب</p> #

<p align="right" dir="rtl" >
 PHP در لینوکس اوبونتو موجود است، اما برخلاف پایتون (که از پیش نصب شده است)، باید به صورت دستی نصب شود.
<br>
 برای نصب PHP – و ماژول Apache PHP – می‌توانید دستور زیر را در خط فرمان وارد کنید:
</p>

```r
sudo apt install php libapache2-mod-php
```


# <p align="right" dir="rtl" > نصب بسته های اختیاری </p> #


<p align="right" dir="rtl" >  بسته‌های زیر اختیاری هستند و در صورت نیاز برای راه‌اندازی، می‌توان آن‌ها را نصب کرد. </p>

    PHP-CLI

<p align="justify" dir="rtl" >    
     شما می توانید اسکریپت های PHP را از طریق رابط خط فرمان (CLI) اجرا کنید.  برای این کار ابتدا باید بسته php-cli را نصب کنید.  با اجرای دستور زیر می توانید آن را نصب کنید:
</p>

```r
sudo apt install php-cli
```

   PHP-CGI

<p align="justify" dir="rtl" >
      همچنین می توانید اسکریپت های PHP را بدون نصب ماژول PHP آپاچی اجرا کنید.  برای انجام این کار، باید بسته php-cgi را از طریق این دستور نصب کنید:
</p>

```r
sudo apt install php-cgi
```

   PHP-MySQL

<p align="right" dir="rtl" >
    برای استفاده از MySQL با PHP باید بسته php-mysql را نصب کنید، مانند:
</p>

```r
sudo apt install php-mysql
```

   PHP-PgSQL

<p align="right" dir="rtl" >
    به طور مشابه، برای استفاده از PostgreSQL با PHP باید بسته php-pgsql را نصب کنید:
</p>

```r
sudo apt install php-pgsql
```

# <p align="right" dir="rtl" >پیکربندی PHP</p> #

<p align="justify" dir="rtl" >
 اگر بسته‌های libapache2-mod-php یا php-cgi را نصب کرده‌اید، می‌توانید اسکریپت‌های PHP را از مرورگر وب خود اجرا کنید.  اگر بسته php-cli را نصب کرده اید، می توانید اسکریپت های PHP را در یک فرمان ترمینال اجرا کنید.
<br>
 به طور پیش فرض، زمانی که libapache2-mod-php نصب می شود، وب سرور Apache2 برای اجرای اسکریپت های PHP با استفاده از این ماژول پیکربندی شده است.  ابتدا بررسی کنید که فایل های /etc/apache2/mods-enabled/php8.*.conf و /etc/apache2/mods-enabled/php8.*.load وجود دارند یا خیر.  اگر آنها وجود ندارند، می توانید ماژول را با استفاده از دستور a2enmod فعال کنید.
<br>
 هنگامی که بسته های مرتبط با PHP را نصب کردید و ماژول Apache PHP را فعال کردید، باید وب سرور Apache2 را برای اجرای اسکریپت های PHP با اجرای دستور زیر مجددا راه اندازی کنید:
</p>

```r
sudo systemctl restart apache2 
```

<p align="right" dir="rtl" >
تنظیمات خود را تست کنید
<br>
 برای تأیید نصب خود، می توانید اسکریپت phpinfo زیر را اجرا کنید:
</p>

```r
<?php
  phpinfo();
?>
```

<p align="right" dir="rtl" >
می‌توانید محتوا را در یک فایل ذخیره کنید - برای مثال phpinfo.php - و آن را در فهرست DocumentRoot سرور وب Apache2 قرار دهید.  با اشاره مرورگر خود به http://hostname/phpinfo.php مقادیر پارامترهای مختلف پیکربندی PHP نمایش داده می شود.
</p>

[منبع](https://ubuntu.com/server/docs/programming-php)

<p align="center" dir="rtl" >صلوات</p>