<p dir="rtl" align="center">بسم الله الرحمن الرحیم</p>


# <p align="right" dir="rtl">نصب PHP </p> 
<p align="right" dir="rtl">
</p>

```r
sudo apt-get update && sudo apt-get upgrade
sudo apt autoremove
```

<p align="right" dir="rtl">
 گزینه (--dry-run) نصب حداقلی  را انجام می دهد:
</p>

```r
sudo apt-get install --dry-run php
```

<p align="right" dir="rtl">
 حال PHP را نصب می کنیم:
<br>
گام 1: به روز رسانی مخازن سیستم
</p>

```r
sodu apt-get update && apt-get upgrade
```
<p align="right" dir="rtl">
گام 2: وابستگی های مورد نیاز را نصب کنید
</p>

```r
sudo apt install -y lsb-release gnupg2 ca-certificates apt-transport-https software-properties-common

```
<p align="right" dir="rtl">
گام 3: مخزن PHP را راه اندازی کنید
</p>

```r
sudo add-apt-repository ppa:ondrej/php
```

<p align="right" dir="rtl">
برای ادامه خواندن اعلان، لطفاً دکمه "Enter" را فشار دهید:
<br>
گام 4: نصب PHP 8.2 در Ubuntu 22.04
</p>

```r
sudo apt update
sudo apt install php8.2
```
<p align="right" dir="rtl">
گام 5: بررسی نسخه PHP 
</p>

```r
php -v
```

<p align="right" dir="rtl">
گام 6: نصب افزونه های PHP8

```r
apt install php8.0-cli php8.0-common php8.0-imap php8.0-redis php8.0-xml php8.0-zip php8.0-mbstring
```
<p align="right" dir="rtl">
گام 7: بررسی ماژولهای نصب شده:
</p>

```r
php -m
```

<p style="background-color:black;color:white;">
    <code>
[PHP Modules]
bcmath
bz2
calendar
Core
ctype
curl
date
.
.
.
<br>
[Zend Modules]
Zend OPcache
</code>
</p>

<p align="right" dir="rtl">
 بررسی نسخه PHP:
</p>

```r
php -version
```

یا

```r
php -v
```

<p style="background-color:black;color:white;">
    <code>
PHP 8.2.12 (cli) (built: Oct 26 2023 17:33:26) (NTS)
Copyright (c) The PHP Group
Zend Engine v4.2.12, Copyright (c) Zend Technologies
   with Zend OPcache v8.2.12, Copyright (c), by Zend Technologies
</code>
</p>


<p dir="rtl" align="center">صلوات</p>