<p dir="rtl" align="center">بسم الله الرحمن الرحیم</p>






# <p align="right" dir="rtl">بررسی بسته های نصب شده روی سرور</p> 


```r
apt list --installed
```

<p align="right" dir="rtl">
بررسی بسته های نصب شده روی سرور از یک سرویس خاص مثل(آپاچی):
</p>


```r
apt list apache2
```

<p align="right" dir="rtl">
بررسی همه نسخه های بسته های نصب شده روی سرور از یک سرویس خاص مثل(آپاچی):
</p>

```r
apt list apache2 -a
```

یا دستور زیر

```r
apt list | grep apache2
```

<p align="right" dir="rtl">
اگر هشدار داد از دستور زیر استفاده کنید
</p>

```r
dpkg --list | grep apache2
```

<p align="right" dir="rtl">
اگر اطلاعات بیشتری می خواهید از دستور زیر بهره ببرید:
</p>


```r
apt list | more
```
و یا

```r
dpkg --list | more
```

# <p align="right" dir="rtl">نصب حداقلی بسته ها</p> 
<p align="right" dir="rtl">
برای نصب حداقلی هر بسته کافیست ابتدا دستور زیر را اجرا نموده و سپس بسته را نصب کنید، به عنوان مثال نصب PHP:
</p>


```r
sudo apt-get install --dry-run php
```

<p align="right" dir="rtl">
توصیه می‌شود که قبل از نصب هر نرم‌افزاری، اجرای حداقلی را انجام دهید. زیرا اطلاعات مفیدی در اختیار شما قرار می‌دهد.
<br>
حال بسته ی مورد نظر را نصب نمائید(مثلاphp):
</p>

```r
sudo apt-get install php
```

<p align="right" dir="rtl">
اگر نسخه خاصی از نرم افزار مد نظر شماست حتما قید کنید، (مثلا php 8.2)
</p>

```r
sudo apt-get install php8.2 -y
```
# <p align="right" dir="rtl">فایروال</p> 
<p align="right" dir="rtl">
اگر  سرویسهای نصب شده اجرا نمی شوند و یا از خارج به آنها دسترسی ندارید، احتمال زیاد دارد که از فایروال باشد و برای آزمایش و به صورت موقت و در ساده ترین حال فایروالها را غیر فعال کنید:<br>
البته توجه داشته باشید که این کار فقط برای آزمایش است و به سرعت بایستی تنظیمات فایروال صورت گرفته و مجدد فعال شود.<br>
دستورات زیر فایروالهای ufw و iptables را غیرفعال می کند:
</p>

```r
sudo ufw disable && sudo iptables disable
```

<p align="right" dir="rtl">
در غیر اینصورت و درصورت آشنایی با فایروال می توانید پورتها و سرویسهایی که لازم است اجرا شود را به فایروال معرفی و اجازه اجرای آن را ثبت نمائید. به عنوان مثال سرویس ssh به صورت پیش فرض پورت 22 استفاده می کند. پس به صورت زیر عمل می کنیم:
</p>

```r
sudo ufw allow ssh && sudo ufw allow 22 && sudo ufw reload
```

<p align="right" dir="rtl">
یا برای اتصال از راه دور به MariaDBبایستی پورت 3306 باز باشد، برای این باید دستور زیر را اجرا کنید :
</p>

```r
sudo ufw allow 3306 && sudo ufw reload
```

<p align="right" dir="rtl">
اما اگر بخواهیم فقط ip خاصی مثلا(192.168.100.100) بتواند به سرور دسترسی داشته باید از دستور زیر استفاده می کنیم:
</p>

```r
sudo ufw allow from 192.168.100.100 to any port 3306  && sudo ufw reload
```

# <p align="right" dir="rtl">SSH</p> 

<p align="right" dir="rtl"> برای اتصال از راه دور به سرور بایستی سرویس SSH  فعال و اجرا شود. با دستورات زیر: </p>

```r
sudo systemctl enable ssh && sudo systemctl start ssh
```

## <p align="right" dir="rtl"> باز کردن سرویس SSH در فایروال: </p> 

```r
sudo ufw allow ssh && sudo ufw reload
```

<p align="right" dir="rtl">نحوه اتصال از راه دور در محیط terminel در سیستم عامل لینوکس و یا CMD در سیستم عامل ویندوز، از دستور زیر استفاده کنید:
  به جای username@ip_address -p port_number مقادیر درست قرار دهید، مثلا:
</p>

```r
ssh root@192.168.100.100 -p 22
``` 

## <p align="right" dir="rtl"> نحوه ی تغییر پورت SSH: </p> 


```r
sudo nano /etc/ssh/sshd_config
```

<p align="right" dir="rtl">باید در این فایل به دنبال یکی از خطوط زیر باشید</p>

<p style="background-color:black;color:white;">
    <code>
Port 22
#Port 22
    </code>
</p>

<p align="right" dir="rtl">
ابتدا #را حذف کنید و سپس به جای عدد 22 شماره پورتی که می خواهید به آن متصل شوید را وارد نمایید. مثلا 2222 سپس با CTRL+O تغییرات را ذخیره نموده و با CTRL+X از فایل خارج شوید.</p>

<p dir="rtl" align="center">صلوات</p>