
<p dir="rtl" align="center">بسم الله الرحمن الرحیم</p>

<div dir="rtl" align="justify">
روش استاندارد یونیکس/لینوکس/اوبونتو برای زمان‌بندی استفاده از cron است.  همچنین می‌توان از systemctl استفاده کرد که بسیار انعطاف‌پذیرتر، اما بسیار پیچیده‌تر است.

 سرویس cron بخشی از نصب استاندارد است، بنابراین احتمالاً قبلاً آن را دارید.  در صورت عدم انجام، به روش معمول نصب کنید:

<div dir="ltr" align="left">

```r
sudo apt install cron
```

</div>
برای زمان‌بندی کارتان، دستور crontab یک زمان‌بندی را در ویرایشگر پیش‌فرض شما باز می‌کند:

<div dir="ltr" align="left">

```r
crontab -e
```

</div>

اگر قبلا ویرایشگر انتخاب نکرده اید، از شما خواسته می شود یکی را انتخاب کنید.  ساده ترین کار برای این کار nano خواهد بود.  سپس فایلی را به شکل زیر ویرایش خواهید کرد:
<p style="background-color:black;color:white;" dir="ltr" align="left">
    <code>
# Edit this file to introduce tasks to be run by cron.
# 
# Each task to run has to be defined through a single line
# indicating with different fields when the task will be run
# and what command to run for the task
# 
# To define the time you can provide concrete values for
# minute (m), hour (h), day of month (dom), month (mon),
# and day of week (dow) or use '*' in these fields (for 'any').
# 
# Notice that tasks will be started based on the cron's system
# daemon's notion of time and timezones.
# 
# Output of the crontab jobs (including errors) is sent through
# email to the user the crontab file belongs to (unless redirected).
# 
# For example, you can run a backup of all your user accounts
# at 5 a.m every week with:
# 0 5 * * 1 tar -zcf /var/backups/home.tgz /home/
# 
# For more information see the manual pages of crontab(5) and cron(8)
# 
# m h  dom mon dow   command
</code>

</p>
به مثال فایل بالا توجه کنید.  برای اجرای اسکریپت پایتون هر روز در ساعت 3 صبح، از ورودی مانند زیر استفاده کنید:

<div dir="ltr" align="left">

```r
0 3 * * * python /path/to/my/script
```

</div>
وقتی از ویرایشگر خارج می‌شوید، کار cron تنظیم می‌شود تا در دفعه بعد که با معیارها مطابقت دارد اجرا شود.  من متوجه هستم که این راه حل بسیار خط فرمان است، اما اشکالی ندارد، زیرا شما این کار را اغلب انجام نمی دهید.  بسیاری از کارهای فانتزی دیگر وجود دارد که می توانید با کرون انجام دهید، مانند اجرای کارها در فواصل زمانی خاص در طول روز.  برای چند مثال مفید، نگاهی به این موارد بیندازید:
<div dir="ltr" align="left">

```r
man 5 crontab
```
</div>

</div>

<p dir="rtl" align="center">صلوات</p>
